;	
;	framuvia.s
;
;	P/ECE Signetics 2637 UVI(Universal Video Interface) Emulator
;
;	CLiP - Common Library for P/ECE
;	Copyright (C) 2001-2005 Naoyuki Sawa
;
;	* Sat Apr 30 13:14:00 JST 2005 Naoyuki Sawa
;	- 쐬JnB
;
#define UVI_DEFINE_OFFSET
#include "clipuvia.h"
#ifdef UVI_ASM

	.code
	.align	1

;****************************************************************************
;	֐ (Video)
;****************************************************************************

	.global	uvi_reduce
uvi_reduce:
	xld.w	%r4, 8				; %r4 = z = 8
uvi_reduce_DO_Z:				; do {
	xld.w	%r5, 16				;   %r5 = y = 16
	xld.w	%r6, 1				;   %r6 = i = 1
uvi_reduce_DO_Y:				;   do {
	xsub	%r6, %r6, 1			;     if(!--i) {
	xjrne.d	uvi_reduce_DO_X1
	ld.w	%r7, 8				;     %r7 = x = 8 *delay*
	;---------------------------------------;
uvi_reduce_DO_X0:				;       do {
	;
	ld.w	%r10, [%r13]+			;         s      = *src++;				// s = [3][2][1][0]
	ld.b	[%r12]+, %r10			;         *dst++ =                s    ; s >>= 8;	// s =    [3][2][1], out =  [0]
	xsrl	%r10, 8
	ld.w	%r11, %r10			;         t      =                s    ; s >>= 8;	// s =       [3][2], t   =  [1]
	xsrl	%r10, 8
	add	%r11, %r10			;         t     +=                s    ; s >>= 8;	// s =          [3], t   =  [1]+[2]
	xsrl	%r10, 8
	ld.ub	%r9, %r11			;         *dst++ = (unsigned char)t / 2;		//                   out = ([1]+[2])/2
	xsrl	%r9, 1
	ld.b	[%r12]+, %r9
	ld.b	[%r12]+, %r10			;         *dst++ =                s    ;		//                   out =  [3]
	;
	ld.w	%r10, [%r13]+			;         s      = *src++;				// s = [7][6][5][4]
	ld.w	%r11, %r10			;         t      =                s    ; s >>= 8;	// s =    [7][6][5], t   =  [4]
	xsrl	%r10, 8
	add	%r11, %r10			;         t     +=                s    ; s >>= 8;	// s =       [7][6], t   =  [4]+[5]
	xsrl	%r10, 8
	ld.ub	%r9, %r11			;         *dst++ = (unsigned char)t / 2;		//                   out = ([4]+[5])/2
	xsrl	%r9, 1
	ld.b	[%r12]+, %r9
	ld.b	[%r12]+, %r10			;         *dst++ =                s    ; s >>= 8;	// s =          [7], out =  [6]
	xsrl	%r10, 8
	ld.w	%r11, %r10			;         t      =                s    ;		//                   t   =  [7]
	;
	ld.w	%r10, [%r13]+			;         s      = *src++;				// s = [B][A][9][8]
	add	%r11, %r10			;         t     +=                s    ; s >>= 8;	// s =    [B][A][9], t   =  [7]+[8]
	xsrl	%r10, 8
	ld.ub	%r9, %r11			;         *dst++ = (unsigned char)t / 2;		//                   out = ([7]+[8])/2
	xsrl	%r9, 1
	ld.b	[%r12]+, %r9
	ld.b	[%r12]+, %r10			;         *dst++ =                s    ; s >>= 8;	// s =       [B][A], out =  [9]
	xsrl	%r10, 8
	ld.w	%r11, %r10			;         t      =                s    ; s >>= 8;	// s =          [B], t   =  [A]
	xsrl	%r10, 8
	add	%r11, %r10			;         t     +=                s    ;		//                   t   =  [A]+[B]
	ld.ub	%r9, %r11			;         *dst++ = (unsigned char)t / 2;		//                   out = ([A]+[B])/2
	xsrl	%r9, 1
	ld.b	[%r12]+, %r9
	;
	ld.w	%r10, [%r13]+			;         s      = *src++;				// s = [F][E][D][C]
	ld.b	[%r12]+, %r10			;         *dst++ =                s    ; s >>= 8;	// s =    [F][E][D], out =  [C]
	xsrl	%r10, 8
	ld.w	%r11, %r10			;         t      =                s    ; s >>= 8;	// s =       [F][E], t   =  [D]
	xsrl	%r10, 8
	add	%r11, %r10			;         t     +=                s    ; s >>= 8;	// s =          [F], t   =  [D]+[E]
	xsrl	%r10, 8
	ld.ub	%r9, %r11			;         *dst++ = (unsigned char)t / 2;		//                   out = ([D]+[E])/2
	xsrl	%r9, 1
	ld.b	[%r12]+, %r9
	ld.b	[%r12]+, %r10			;         *dst++ =                s    ;		//                   out =  [F]
	;
	xsub	%r7, %r7, 1			;       } while(--x)
	xjrne	uvi_reduce_DO_X0
	xjp.d	uvi_reduce_LOOP_Y
	ld.w	%r6, 3				;       i = 3 *delay*
	;---------------------------------------;     } else {
uvi_reduce_DO_X1:				;       do {
	;
	xld.w	%r10, [%r13+128]		;         s      = src[128];
	ld.w	%r9, [%r13]+			;         s     += *src++;				// s = [3][2][1][0]
	add	%r10, %r9		
	ld.ub	%r9, %r10			;         *dst++ = (unsigned char)s / 2; s >>= 8;	// s =    [3][2][1], out = ([0]    )/2
	xsrl	%r9, 1
	ld.b	[%r12]+, %r9
	xsrl	%r10, 8
	ld.w	%r11, %r10			;         t      =                s    ; s >>= 8;	// s =       [3][2], t   =  [1]
	xsrl	%r10, 8
	add	%r11, %r10			;         t     +=                s    ; s >>= 8;	// s =          [3], t   =  [1]+[2]
	xsrl	%r10, 8
	ld.ub	%r9, %r11			;         *dst++ = (unsigned char)t / 4;		//                   out = ([1]+[2])/4
	xsrl	%r9, 2
	ld.b	[%r12]+, %r9
	ld.ub	%r9, %r10			;         *dst++ = (unsigned char)s / 2;		//                   out = ([3]    )/2
	xsrl	%r9, 1
	ld.b	[%r12]+, %r9
	;
	xld.w	%r10, [%r13+128]		;         s      = src[128];
	ld.w	%r9, [%r13]+			;         s     += *src++;				// s = [7][6][5][4]
	add	%r10, %r9
	ld.w	%r11, %r10			;         t      =                s    ; s >>= 8;	// s =    [7][6][5], t   =  [4]
	xsrl	%r10, 8
	add	%r11, %r10			;         t     +=                s    ; s >>= 8;	// s =       [7][6], t   =  [4]+[5]
	xsrl	%r10, 8
	ld.ub	%r9, %r11			;         *dst++ = (unsigned char)t / 4;		//                   out = ([4]+[5])/4
	xsrl	%r9, 2
	ld.b	[%r12]+, %r9
	ld.ub	%r9, %r10			;         *dst++ = (unsigned char)s / 2; s >>= 8;	// s =          [7], out = ([6]    )/2
	xsrl	%r9, 1
	ld.b	[%r12]+, %r9
	ld.w	%r11, %r10			;         t      =                s    ;		//                   t   =  [7]
	;
	xld.w	%r10, [%r13+128]		;         s      = src[128];
	ld.w	%r9, [%r13]+			;         s     += *src++;				// s = [B][A][9][8]
	add	%r10, %r9
	add	%r11, %r10			;         t     +=                s    ; s >>= 8;	// s =    [B][A][9], t   =  [7]+[8]
	xsrl	%r10, 8
	ld.ub	%r9, %r11			;         *dst++ = (unsigned char)t / 4;		//                   out = ([7]+[8])/4
	xsrl	%r9, 2
	ld.b	[%r12]+, %r9
	ld.ub	%r9, %r10			;         *dst++ = (unsigned char)s / 2; s >>= 8;	// s =       [B][A], out = ([9]    )/2
	xsrl	%r9, 1
	ld.b	[%r12]+, %r9
	xsrl	%r10, 8
	ld.w	%r11, %r10			;         t      =                s    ; s >>= 8;	// s =          [B], t   =  [A]
	xsrl	%r10, 8
	add	%r11, %r10			;         t     +=                s    ;		//                   t   =  [A]+[B]
	ld.ub	%r9, %r11			;         *dst++ = (unsigned char)t / 4;		//                   out = ([A]+[B])/4
	xsrl	%r9, 2
	ld.b	[%r12]+, %r9
	;
	xld.w	%r10, [%r13+128]		;         s      = src[128];
	ld.w	%r9, [%r13]+			;         s     += *src++;				// s = [F][E][D][C]
	add	%r10, %r9
	ld.ub	%r9, %r10			;         *dst++ = (unsigned char)s / 2; s >>= 8;	// s =    [F][E][D], out = ([C]    )/2
	xsrl	%r9, 1
	ld.b	[%r12]+, %r9
	xsrl	%r10, 8
	ld.w	%r11, %r10			;         t      =                s    ; s >>= 8;	// s =       [F][E], t   =  [D]
	xsrl	%r10, 8
	add	%r11, %r10			;         t     +=                s    ; s >>= 8;	// s =          [F], t   =  [D]+[E]
	xsrl	%r10, 8
	ld.ub	%r9, %r11			;         *dst++ = (unsigned char)t / 4;		//                   out = ([D]+[E])/4
	xsrl	%r9, 2
	ld.b	[%r12]+, %r9
	ld.ub	%r9, %r10			;         *dst++ = (unsigned char)s / 2;		//                   out = ([F]    )/2
	xsrl	%r9, 1
	ld.b	[%r12]+, %r9
	;
	xsub	%r7, %r7, 1			;       } while(--x)
	xjrne	uvi_reduce_DO_X1
	xadd	%r13, %r13, 128			;       src += 128
	;---------------------------------------;     }
uvi_reduce_LOOP_Y:
	xsub	%r5, %r5, 1			;   } while(--y)
	xjrne	uvi_reduce_DO_Y
	xsub	%r4, %r4, 1			; } while(--z)
	xjrne	uvi_reduce_DO_Z
	ret

;****************************************************************************
;	
;****************************************************************************

#endif /*UVI_ASM*/
